﻿var changes = { "addedStyles": [{ "selector": ".igte_Edit", "newStyles": [{ "name": "padding", "value": "0px" }, { "name": "border-radius", "value": "0px" }, { "name": "box-shadow", "value": "none" }] }, { "selector": ".igte_Focus", "newStyles": [{ "name": "box-shadow", "value": "none" }] }, { "selector": ".igeb_Group", "newStyles": [{ "name": "background-color", "value": "black" }, { "name": "border", "value": "0px" }, { "name": "border-radius", "value": "0px" }, { "name": "border-color", "value": "black" }, { "name": "font-size", "value": "14px" }] }], "removedStyles": [{ "selector": ".igeb_Group", "styles": ["background-image", "border-width"] }, { "selector": ".igeb_Control", "styles": ["border-color", "border-style", "border-width", "font-family", "font-size"] }, { "selector": ".igeb_GroupLabel", "styles": ["font-family", "font-weight"] }, { "selector": ".igeb_Group a", "styles": ["color"] }, { "selector": ".igeb_ItemLabel", "styles": ["font-size", "font-family"] }, { "selector": ".igeb_ItemHover", "styles": ["background-color"] }, { "selector": ".igeb_ItemActive", "styles": ["background-color", "color"] }, { "selector": ".igeb_ItemSelected", "styles": ["color", "background-color", "background-repeat"] }], "linkedStyles": [{ "selector": ".igte_Edit", "links": [{ "name": "font-size", "link": { "styleSheet": "http://bootstrapmanager.azurewebsites.net/Content/bootstrap.css", "cssRule": ".form-control", "setting": "font-size" } }, { "name": "padding", "link": { "styleSheet": "http://bootstrapmanager.azurewebsites.net/Content/bootstrap.css", "cssRule": ".form-control", "setting": "padding" } }, { "name": "border", "link": { "styleSheet": "http://bootstrapmanager.azurewebsites.net/Content/bootstrap.css", "cssRule": ".form-control", "setting": "border" } }, { "name": "border-radius", "link": { "styleSheet": "http://bootstrapmanager.azurewebsites.net/Content/bootstrap.css", "cssRule": ".form-control", "setting": "border-radius" } }, { "name": "box-shadow", "link": { "styleSheet": "http://bootstrapmanager.azurewebsites.net/Content/bootstrap.css", "cssRule": ".form-control", "setting": "box-shadow" } }] }, { "selector": ".igte_Focus", "links": [{ "name": "border-color", "link": { "styleSheet": "http://bootstrapmanager.azurewebsites.net/Content/bootstrap.css", "cssRule": ".form-control:focus", "setting": "border-color" } }, { "name": "box-shadow", "link": { "styleSheet": "http://bootstrapmanager.azurewebsites.net/Content/bootstrap.css", "cssRule": ".form-control:focus", "setting": "box-shadow" } }] }, { "selector": ".igeb_Group", "links": [{ "name": "background-color", "link": { "styleSheet": "http://bootstrapmanager.azurewebsites.net/Content/bootstrap.css", "cssRule": ".panel-default > .panel-heading", "setting": "background-color" } }, { "name": "border", "link": { "styleSheet": "http://bootstrapmanager.azurewebsites.net/Content/bootstrap.css", "cssRule": ".panel", "setting": "border" } }, { "name": "border-radius", "link": { "styleSheet": "http://bootstrapmanager.azurewebsites.net/Content/bootstrap.css", "cssRule": ".panel", "setting": "border-radius" } }, { "name": "border-color", "link": { "styleSheet": "http://bootstrapmanager.azurewebsites.net/Content/bootstrap.css", "cssRule": ".panel-default > .panel-heading", "setting": "border-color" } }, { "name": "font-size", "link": { "styleSheet": "http://bootstrapmanager.azurewebsites.net/Content/bootstrap.css", "cssRule": ".panel-title", "setting": "font-size" } }] }, { "selector": ".igeb_GroupLabel", "links": [{ "name": "font-size", "link": { "styleSheet": "http://bootstrapmanager.azurewebsites.net/Content/bootstrap.css", "cssRule": ".panel-title", "setting": "font-size" } }] }] };

function defaultStyleValue(settingName, defaultStyle) {
  var value = defaultStyle[settingName];
  if (!value) {
    var mapDefaults = {
      "background": "transparent none repeat scroll",
      "border-width": "0px",
      "border-style": "none",
      "border-color": "transparent",
      "border-top": "0px none transparent",
      "border-bottom": "0px none transparent",
      "border-left": "0px none transparent",
      "border-right": "0px none transparent",
      "border": "0px none transparent",
      "padding": "0px",
      "margin": "0px",
      "font-family": "inherit",
      "font-size": "inherit",
      "font-weight": "normal",
      "color": "black",
      "background-color": "transparent",
      "background-image": "none"
    };
    value = mapDefaults[settingName] || "";
  }
  return value;
}

function findStyleSheet(id) {
  for (var i = 0; i < document.styleSheets.length; i++) {
    var ss = document.styleSheets[i];
    if (ss.href == id || ss.id == id || id == i)
      return ss;
  }
  return null;
}

function findCssRule(styleSheet, selector) {
  if (!styleSheet || !styleSheet.cssRules)
    return null;
  for (var i = 0; i < styleSheet.cssRules.length; i++) {
    var rule = styleSheet.cssRules[i];
    if (rule.selectorText == selector)
      return rule;
  }
  return null;
}

function getStyleSettings(cssRule) {
  if (!cssRule.cssText)
    return null;

  var cssText = cssRule.cssText;
  var openBr = cssText.indexOf("{");
  var closeBr = cssText.indexOf("}");
  cssText = cssText.substring(openBr + 1, closeBr);

  var settings = cssText.split(";");
  var styles = [];
  for (var i = 0; i < settings.length; i++) {
    if (!settings[i] || !settings[i].trim())
      continue;

    var indexOfColon = settings[i].indexOf(":");
    if (indexOfColon < 0)
      continue;
    var name = settings[i].substring(0, indexOfColon);
    var value = settings[i].substring(indexOfColon + 1);

    styles.push({ name: name.trim(), value: value.trim() });
  }
  return styles;
}

function findStyleSetting(rule, setting) {
  if (!rule)
    return null;
  var styles = getStyleSettings(rule);
  for (var i = 0; styles && i < styles.length; i++) {
    var s = styles[i];
    if (s.name == setting)
      return s;
  }
  return null;
}

function injectChanges(changes) {
  var styleEl = $("#__injectedStyles");
  if (styleEl.length)
    styleEl[0].parentNode.removeChild(styleEl[0]);

  styleEl = document.createElement("style");
  styleEl.setAttribute("rel", "stylesheet");
  styleEl.setAttribute("id", "__injectedStyles");
  document.body.appendChild(styleEl);

  var injectedStyles = document.styleSheets[document.styleSheets.length - 1];

  var emptyDiv = emptyDiv = document.createElement("div");
  emptyDiv.setAttribute("id", "__emptyDiv");

  document.body.appendChild(emptyDiv);

  var emptyStyle = emptyDiv.getComputedStyle ? emptyDiv.getComputedStyle() : (emptyDiv.currentStyle ? emptyDiv.currentStyle : emptyDiv.style);

  for (var i = 0; changes.addedStyles && i < changes.addedStyles.length; i++) {
    var addStyle = changes.addedStyles[i];

    console.log("+ " + addStyle.selector);

    var cssText = "";
    for (var j = 0; j < addStyle.newStyles.length; j++) {
      var addSettingName = addStyle.newStyles[j].name;
      var addSettingValue = addStyle.newStyles[j].value;
      var addSetting = addSettingName + ": " + addSettingValue + ";";
      console.log(addSetting);
      cssText += addSetting;
    }

    if (injectedStyles.insertRule) {
      injectedStyles.insertRule(addStyle.selector + " {" + cssText + "}", injectedStyles.cssRules ? injectedStyles.cssRules.length : 0);
    }
    else if (injectedStyles.addRule) {
      injectedStyles.addRule(addStyle.selector, cssText);
    }
  }

  for (var i = 0; changes.removedStyles && i < changes.removedStyles.length; i++) {
    var remStyle = changes.removedStyles[i];

    console.log("- " + remStyle.selector);

    var cssText = "";
    for (var j = 0; j < remStyle.styles.length; j++) {
      var remSettingName = remStyle.styles[j];
      var remSettingValue = defaultStyleValue(remSettingName, emptyStyle);
      if (remSettingValue) {
        var remSetting = remSettingName + ": " + remSettingValue + ";";
        console.log(remSetting);
        cssText += remSetting;
      }
      else {
        console.log("Could not find default value for: " + remSettingName);
      }
    }

    if (injectedStyles.insertRule) {
      injectedStyles.insertRule(remStyle.selector + " {" + cssText + "}", injectedStyles.cssRules ? injectedStyles.cssRules.length : 0);
    }
    else if (injectedStyles.addRule) {
      injectedStyles.addRule(remStyle.selector, cssText);
    }
  }

  for (var i = 0; changes.linkedStyles && i < changes.linkedStyles.length; i++) {
    var linkStyle = changes.linkedStyles[i];

    console.log("s " + linkStyle.selector);

    var cssText = "";
    for (var j = 0; j < linkStyle.links.length; j++) {
      var linkedStyle = linkStyle.links[j];
      var styleSheet = findStyleSheet(linkedStyle.link.styleSheet);
      var cssRule = findCssRule(styleSheet, linkedStyle.link.cssRule);
      var styleSetting = findStyleSetting(cssRule, linkedStyle.link.setting);
      if (styleSetting) {
        var linkSetting = linkedStyle.name + ": " + styleSetting.value + ";";
        console.log(linkSetting);
        cssText += linkSetting;
      }
      else {
        console.log("Could not find linked style for: " + JSON.stringify(linkedStyle.link));
      }
    }

    if (injectedStyles.insertRule) {
      injectedStyles.insertRule(linkStyle.selector + " {" + cssText + "}", injectedStyles.cssRules ? injectedStyles.cssRules.length : 0);
    }
    else if (injectedStyles.addRule) {
      injectedStyles.addRule(linkStyle.selector, cssText);
    }
  }

  document.body.removeChild(emptyDiv);
}

$(function () {
  injectChanges(changes);
});
